package com.ruoyi.web.backgroud.client;

import com.ruoyi.web.bo.XML82Bo;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import java.io.StringReader;

@Slf4j
@ChannelHandler.Sharable
public class BackgroundClientHandler extends SimpleChannelInboundHandler<String> {

    private BackgroundClientNetty client;

    public BackgroundClientHandler(BackgroundClientNetty client) {
        this.client = client;
    }

    private XML82Bo xmlToObject(String xmlString) {
        XML82Bo xml82Bo = new XML82Bo();
        try {
            JAXBContext context = JAXBContext.newInstance(XML82Bo.class);
            Unmarshaller unmarshaller = context.createUnmarshaller();
            StringReader reader = new StringReader(xmlString);
            xml82Bo = (XML82Bo) unmarshaller.unmarshal(reader);
        } catch (JAXBException e) {
            e.printStackTrace();
        }

        return xml82Bo;
    }

    //接收服务端返回的82报文
    @Override
    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
        /**
         <?xml version="1.0" encoding="GB2312"?>
         <GATHER_FEEDBACK>
             <AREA_ID>7230000LZB</AREA_ID>
             <CHNL_NO>72300HE101</CHNL_NO>
             <SESSION_ID>72300HE10120201102092243</SESSION_ID>
             <CHECK_RESULT>Y</CHECK_RESULT>
             <OP_HINT>【智能卡口】海关放行</OP_HINT>
             <LED_HINT>请通行</LED_HINT>
             <EXTENDED_CONTENT></EXTENDED_CONTENT>
         </GATHER_FEEDBACK>
         */
        System.out.println("---------客户端接收返回的82报文："+ msg);
        XML82Bo xml82Bo = xmlToObject(msg);


    }


    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        log.error("-------------后端服务器连接断开,{}-----------，进行重连", ctx.channel().remoteAddress());
        client.connect();
    }
}
