package com.ruoyi.web.controller;

import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.web.bo.GatherBo;
import com.ruoyi.web.bo.ReleaseBo;
import com.ruoyi.web.bo.ResponseBo;
import com.ruoyi.web.config.AesEncryptUtil;
import com.ruoyi.web.entity.GatherData;
import com.ruoyi.web.entity.Release;
import com.ruoyi.web.service.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/interaction")
@Slf4j
public class ProcessController {

    @Autowired
    private ProcessService processService;
    @Autowired
    private CustomsService customsService;
    @Autowired
    private ReservationService reservationService;

    @PostMapping("/process")
    public ResponseBo process(@RequestBody String content) {
        log.info("---------------开始---------------");
        String decrypt = AesEncryptUtil.AESDecrypt(content);
        GatherBo bo = JSONObject.parseObject(decrypt, GatherBo.class);
        log.info("GatherBo:{}", JSONUtil.toJsonStr(bo));


        GatherData gatherData = new GatherData();
        gatherData.setSteps(bo.getSteps());

        gatherData.setJsStatus(bo.getJsStatus());
        gatherData.setContainerStatus(bo.getContainerStatus());

        gatherData.setIsEmpty(bo.getIsEmpty());
        gatherData.setIsLoaded(bo.getIsLoaded());

        gatherData.setCrossCode(bo.getCrossCode());
        gatherData.setCntrnoF(bo.getCntrnoF());
        gatherData.setCntrnoA(bo.getCntrnoA());
        gatherData.setCntrnoFType(bo.getCntrnoFType());
        gatherData.setCntrnoAType(bo.getCntrnoAType());


        //进出标识，I进E出
        gatherData.setI_E_FLAG(bo.getIeFlag());
        //场站号，固定写为场所分配的场站号
        gatherData.setAREA_ID(bo.getAreaId());
        //通道号，已经从通道号配置文件中读取
        gatherData.setCHNL_NO(bo.getChnlNo());
        //通道业务类型，通常为A，已经读取
        gatherData.setGETHER_MODE(bo.getGetherMode());
        //会话编号，自动生成
        //gatherData.setSESSION_ID(bo.getSessionId());

        //IC卡配置信息
        //读取到的IC卡号
        gatherData.setIC_ID(bo.getIcId());
        gatherData.setIC_GOODS_NAME(bo.getIcGoodsName());
        gatherData.setIC_BILL_NO(bo.getIcBillNo());
        gatherData.setIC_NO(bo.getIcNo());
        gatherData.setIC_Type(bo.getIcType());
        gatherData.setIC_EXTENDED_CONTENT(bo.getIcExtendedContent());

        gatherData.setDR_CUSTOMS_NO(bo.getDrCustomsNo());
        gatherData.setVE_CUSTOMS_NO(bo.getVeCustomsNo());
        //读取到的车牌号信息
        gatherData.setVE_LICENSE_NO(bo.getVeLicenseNo());
        gatherData.setESEAL_ID(bo.getEsealId());
        //读取到的地磅重量——>KG转换为吨在散货service方法中处理，此处不做处理
        gatherData.setGROSS_WT(bo.getGrossWt());

        //VE_RFID信息
        //RFID卡号信息
        gatherData.setVE_RFID_ID(bo.getVeRfidId());
        //RFID绑定的光学车牌信息
        gatherData.setVE_LICENSE_NO_RFID(bo.getVeLicenseNoRfid());
        gatherData.setVE_CUSTOMS_NO_RFID(bo.getVeCustomsNoRfid());
        gatherData.setVE_WT_RFID(bo.getVeWtRfid());
        gatherData.setVE_COMPANY_RFID(bo.getVeCompanyRfid());
        gatherData.setVE_PERFORMANCE_RFID(bo.getVePerformanceRfid());

        //DR_RFID信息
        gatherData.setDR_RFID_ID(bo.getDrRfidId());
        gatherData.setDR_NAME(bo.getDrName());
        gatherData.setDR_CUSTOMS_NO_RFID(bo.getDrCustomsNoRfid());
        gatherData.setDR_COMPANY(bo.getDrCompany());
        gatherData.setDR_PERFORMANCE(bo.getDrPerformance());

        gatherData.setOPERATOR_ID(bo.getOperatorId());
        gatherData.setOPERATE_TIME(bo.getOperateTime());


        gatherData.setDOMESTIC_LICENSE_NO(bo.getDomesticLicenseNo());
        //车牌图片保存路径，如有箱号，有箱号图片路径
        gatherData.setDOMESTIC_LICENSE_COLOR(bo.getDomesticLicenseColor());
        gatherData.setFOREIGN_LICENSE_NO(bo.getForeignLicenseNo());
        gatherData.setFOREIGN_LICENSE_COLOR(bo.getForeignLicenseColor());
        gatherData.setCONFIDENCE_RATIO(bo.getConfidenceRatio());
        gatherData.setGateNo(bo.getGateNo());
        gatherData.setPlaceCode(bo.getPlaceCode());
        gatherData.setIsSendPlaceCode(bo.getIsSendPlaceCode());

        return processService.process(gatherData);
    }

    @PostMapping("/sendRelease")
    public ResponseBo sendRelease(@RequestBody String content) {
        String decrypt = AesEncryptUtil.AESDecrypt(content);
        ReleaseBo bo = JSONObject.parseObject(decrypt, ReleaseBo.class);

        Release release = new Release();
        release.setI_E_FLAG(bo.getIeFlag());
        release.setAREA_ID(bo.getAreaId());
        release.setCHNL_NO(bo.getChnlNo());
        release.setESEAL_USE_COUNT(bo.getEsealUseCount());
        return customsService.sendReleaseData(release);
    }

    @PostMapping("/reservation")
    public ResponseBo reservation(@RequestBody String content) {
        String veLicenseNo = AesEncryptUtil.AESDecrypt(content);

        ResponseBo res = reservationService.reservation(veLicenseNo);
        return res;
    }

}
