package com.ruoyi.web.entity;

import com.ruoyi.web.bo.Steps;
import lombok.Data;

import java.util.List;
import java.util.Set;

/**
 * 采集数据(0x21)
 */
@Data
public class GatherData {

    private List<Steps> steps;

    private Set<String> cntrnoList;

    //集装箱或散货接口调用状态：0=默认值 1=通过
    private Integer jsStatus;
    //海关接口调用状态：0=默认值 1=通过
    private Integer containerStatus;

    //0=不验空箱,1=需验空箱
    private Integer isEmpty;
    //0=不验重箱,1=需验重箱
    private Integer isLoaded;

    //道口号
    private String crossCode;
    //前箱号
    private String cntrnoF;
    //前箱的 UNISO 代码
    private String cntrnoFType;
    //后箱号
    private String cntrnoA;
    //后箱的UNISO 代码
    private String cntrnoAType;

    //进出标识，I进E出
    private String I_E_FLAG;
    //场站号，固定写为场所分配的场站号
    private String AREA_ID;
    //通道号，已经从通道号配置文件中读取
    private String CHNL_NO;
    //通道业务类型，通常为A，已经读取
    private String GETHER_MODE;
    //会话编号，自动生成
    private String SESSION_ID;

    //IC卡配置信息
    //读取到的IC卡号
    private String IC_ID;
    private String IC_GOODS_NAME;
    private String IC_BILL_NO;
    private String IC_NO;
    private String IC_Type;
    private String IC_EXTENDED_CONTENT;

    private String DR_CUSTOMS_NO;
    private String VE_CUSTOMS_NO;
    //读取到的车牌号信息
    private String VE_LICENSE_NO;
    private String ESEAL_ID;
    //读取到的地磅重量
    private double GROSS_WT;

    //VE_RFID信息
    //RFID卡号信息
    private String VE_RFID_ID;
    //RFID绑定的光学车牌信息
    private String VE_LICENSE_NO_RFID;
    private String VE_CUSTOMS_NO_RFID;
    private String VE_WT_RFID;
    private String VE_COMPANY_RFID;
    private String VE_PERFORMANCE_RFID;

    //DR_RFID信息
    private String DR_RFID_ID;
    private String DR_NAME;
    private String DR_CUSTOMS_NO_RFID;
    private String DR_COMPANY;
    private String DR_PERFORMANCE;

    private String OPERATOR_ID;
    private String OPERATE_TIME;

    //车牌图片保存路径，如有箱号，有箱号图片路径
    private String DOMESTIC_LICENSE_NO;
    private String DOMESTIC_LICENSE_COLOR;
    private String FOREIGN_LICENSE_NO;
    private String FOREIGN_LICENSE_COLOR;
    private String CONFIDENCE_RATIO;
    /**
     * 散货过磅地点
     */
    private String placeCode;
    /**
     * 散货道口号
     */
    private String gateNo;
    /**
     * 接口是否发送——散货过磅地点:0=不发送,1=发送
     */
    private Integer isSendPlaceCode;
}
