package com.ruoyi.web.service;

import com.ruoyi.web.bo.ResponseBo;
import com.ruoyi.web.bo.Steps;
import com.ruoyi.web.entity.GatherData;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class ProcessService {
    @Autowired
    private ReservationService reservationService;
    @Autowired
    private CustomsService customsService;
    @Autowired
    private ContainerService containerService;
    @Autowired
    private BulkloadService bulkloadService;
    @Autowired
    private SendSocket81Service sendSocket81Service;

    public ResponseBo process(GatherData gatherData) {
        Integer jsStatus = gatherData.getJsStatus();
        Integer containerStatus = gatherData.getContainerStatus();

        List<Steps> stepsList = gatherData.getSteps();
        if(stepsList.contains("gateIdentify")) {
            //当前接口为联运中心智慧闸口接口，全部调用
        } else if(0 == jsStatus && 0 == containerStatus) {
            //为初始值0，所有接口都要调用
        } else if(1 == jsStatus && 0 == containerStatus) {
            stepsList.removeIf(steps ->
                    "reservation".equalsIgnoreCase(steps.getApi()) //预约接口
                            || "GetBookingInfo".equalsIgnoreCase(steps.getApi()) //集装箱接口
                            || "LogOn".equalsIgnoreCase(steps.getApi()) //散货接口
                            || "reservationToSorJ".equalsIgnoreCase(steps.getApi())); //预约接口——>集装箱接口/散货接口(通道为综合类型)
        } else if(1 == jsStatus && 1 == containerStatus) {
            //当前情况暂定为第二次作业，重走新流程，，所有接口都要调用
        }


        List<Steps> collect = stepsList.stream().filter(steps -> "sendGatherData".equalsIgnoreCase(steps.getApi())).collect(Collectors.toList());
        if(collect.size() == 0) {//没有海关，海关状态改为2
            containerStatus = 2;
        }
        List<Steps> collect1 = stepsList.stream().filter(steps -> "GetBookingInfo".equalsIgnoreCase(steps.getApi())||"LogOn".equalsIgnoreCase(steps.getApi())).collect(Collectors.toList());
        if(collect1.size() == 0) {//没有集装箱或散货，集装箱/散货状态改为2
            jsStatus = 2;
        }


        String TRUCK_NO = gatherData.getVE_LICENSE_NO();
        ResponseBo res = new ResponseBo();
        String examineState = "";
        log.info("---------------stepsList:"+stepsList.toString());
        for (Steps steps:stepsList) {
            if("reservation".equalsIgnoreCase(steps.getApi())) {//预约接口
                res = reservationService.reservation(TRUCK_NO);
                res.setJsStatus(gatherData.getJsStatus());
                res.setContainerStatus(gatherData.getContainerStatus());
                examineState = res.getExamineState();
                if(500 == res.getCode()) return res;
            }
            else if("sendGatherData".equalsIgnoreCase(steps.getApi())) {//海关接口-发送采集数据
                res = customsService.sendGatherData(gatherData);
                containerStatus = gatherData.getContainerStatus();
                if(500 == res.getCode()) return res;
            }
            else if("sendSocket".equalsIgnoreCase(steps.getApi())) {//socket方式发送81报文
                sendSocket81Service.sendSocket(gatherData);
                containerStatus = gatherData.getContainerStatus();
                if(500 == res.getCode()) return res;
            }
            else if("GetBookingInfo".equalsIgnoreCase(steps.getApi())) {//集装箱接口
                examineState = "有集装箱预约";
                if("I".equalsIgnoreCase(gatherData.getI_E_FLAG())) {
                    res = containerService.GetBookingInfo(gatherData);
                } else {
                    res = containerService.CONFIRM_OUTYARD(gatherData);
                }
                jsStatus = res.getJsStatus();
                if(500 == res.getCode()) return res;
            }
            else if("LogOn".equalsIgnoreCase(steps.getApi())) {//散货接口
                examineState = "有散杂货预约";
                res = bulkloadService.LogOn(gatherData);
                jsStatus = res.getJsStatus();
                if(500 == res.getCode()) return res;
            }
            else if("reservationToSorJ".equalsIgnoreCase(steps.getApi())) {//预约接口——>集装箱接口/散货接口(通道为综合类型)
                res = reservationService.reservationToSorJ(gatherData);
                jsStatus = res.getJsStatus();
                examineState = res.getExamineState();
                if(500 == res.getCode()) return res;
            }
            else if("reservationToSorJ_Test".equalsIgnoreCase(steps.getApi())) {//预约接口——>集装箱接口/散货接口(通道为综合类型)——>测试(没有预约接口)
                res = reservationService.reservationToSorJ_Test(gatherData);
                jsStatus = res.getJsStatus();
                examineState = res.getExamineState();
                if(500 == res.getCode()) return res;
            }
        }

        res.setExamineState(examineState);
        res.setJsStatus(jsStatus);
        res.setContainerStatus(containerStatus);
        log.info("---------------res："+res.toString());
        log.info("---------------结束---------------");
        return res;
    }


}
