package com.ruoyi.web.service;

import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.web.bo.ResponseBo;
import com.ruoyi.web.config.ConfigComponent;
import com.ruoyi.web.config.RestUtil;
import com.ruoyi.web.entity.Base;
import com.ruoyi.web.entity.GatherData;
import com.ruoyi.web.entity.Reservation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * 散杂货、集装箱预约状态查询接口调用-业务处理
 */
@Slf4j
@Service
public class ReservationService {

    private static final HttpHeaders headers = new HttpHeaders();
    @Autowired
    private ConfigComponent configComponent;
    @Autowired
    private ContainerService containerService;
    @Autowired
    private BulkloadService bulkloadService;

    /**
     * 预约接口
     * @param TRUCK_NO 车牌号
     */
    public ResponseBo reservation(String TRUCK_NO) {
        ResponseBo res = new ResponseBo();
        //请求地址
        String url = configComponent.getReservationUrl() + "?carNumber=" + TRUCK_NO;

        //url = configComponent.getInVerificationUrl() + "?TruckNo=" + gatherData.getVE_LICENSE_NO() + "&PLACE_CODE=" + gatherData.getPlaceCode();

        //返回预约结果对象
        //获取预约状态接口调用失败，默认集装箱处理。
        /*{
            "code": 200,
            "msg": "获取散杂货、集装箱预约状态成功",
            "data": {
                "carNumber": "桂E12345",
                "sExamineState": "01"
                "jExamineState": "00"
            }
        }*/
        /*JSONObject result = RestUtil.get(url, headers);
        Base base = JSONObject.parseObject(result.toString(), Base.class);
        res.setCode(base.getCode());
        res.setMsg(base.getMsg());
        if(200 == base.getCode()) {
            Reservation reservation = JSONObject.parseObject(base.getData(), Reservation.class);

            if("00".equals(reservation.getSExamineState())&&"01".equals(reservation.getJExamineState())) {
                res.setExamineState("有集装箱预约");
            } else if("01".equals(reservation.getSExamineState())&&"00".equals(reservation.getJExamineState())) {
                res.setExamineState("有散杂货预约");
            } else if("00".equals(reservation.getSExamineState())&&"00".equals(reservation.getJExamineState())) {
                res.setExamineState("没有预约");
                res.setMsg("没有预约");
                res.setCode(500);
            }
        }*/

        res.setExamineState("没有预约");
        res.setMsg("没有预约");
        res.setCode(500);
        return res;
    }

    /**
     * 预约接口——>集装箱接口/散货接口(通道为综合类型)
     */
    public ResponseBo reservationToSorJ(GatherData gatherData) {
        String examineState = "";
        ResponseBo res = new ResponseBo();
        //请求地址
        String url = configComponent.getReservationUrl() + "?carNumber=" + gatherData.getVE_LICENSE_NO();

        //返回预约结果对象
        //获取预约状态接口调用失败，默认集装箱处理。
        /*{
            "code": 200,
            "msg": "获取散杂货、集装箱预约状态成功",
            "data": {
                "carNumber": "桂E12345",
                "sExamineState": "01"
                "jExamineState": "00"
            }
        }*/
        /*JSONObject result = RestUtil.get(url, headers);
        Base base = JSONObject.parseObject(result.toString(), Base.class);
        res.setCode(base.getCode());
        res.setMsg(base.getMsg());*/
        Base base = new Base();
        base.setCode(200);
        base.setMsg("获取散杂货、集装箱预约状态成功");
        base.setData("{\"carNumber\": \"桂E12345\",\"sExamineState\": \"01\",\"jExamineState\": \"00\"}");

        res.setCode(base.getCode());
        res.setMsg(base.getMsg());
        if(200 == base.getCode()) {
            Reservation reservation = JSONObject.parseObject(base.getData(), Reservation.class);

            if("00".equals(reservation.getSExamineState())&&"01".equals(reservation.getJExamineState())) {
                res = containerService.GetBookingInfo(gatherData);
                res.setExamineState("有集装箱预约");
            } else if("01".equals(reservation.getSExamineState())&&"00".equals(reservation.getJExamineState())) {
                res = bulkloadService.LogOn(gatherData);
                res.setExamineState("有散杂货预约");
            } else if("00".equals(reservation.getSExamineState())&&"00".equals(reservation.getJExamineState())) {
                res.setExamineState("没有预约");
                res.setCode(500);
                res.setMsg("没有预约");
            }
        }
        return res;
    }

    /**
     * 预约接口——>集装箱接口/散货接口(通道为综合类型)——>测试
     */
    public ResponseBo reservationToSorJ_Test(GatherData gatherData) {
        ResponseBo res = new ResponseBo();
        //if("I".equalsIgnoreCase(gatherData.getI_E_FLAG())) {//进港
            res = bulkloadService.LogOn(gatherData);
            res.setExamineState("有散杂货预约");
            if(("散货无预约".equals(res.getFlag()) || res.getMsg().contains("登录失败")) && 500 == res.getCode()) {
                res = containerService.GetBookingInfo(gatherData);
                res.setExamineState("有集装箱预约");
                if("未知".equals(res.getFlag()) && 500 == res.getCode()) {
                    res.setExamineState("未知");
                    return res;
                }
                if("集装箱无预约".equals(res.getFlag()) && 500 == res.getCode()) {
                    log.info("---------------------没有预约------------------");
                    res.setExamineState("没有预约");
                    return res;
                }
            }
            return res;
        /*} else {
            res = containerService.CONFIRM_OUTYARD(gatherData);
            res.setExamineState("有集装箱预约");
            if("集装箱无预约".equals(res.getFlag()) && 500 == res.getCode() && StringUtils.isEmpty(gatherData.getCntrnoF()) && StringUtils.isEmpty(gatherData.getCntrnoA())) {
                res = bulkloadService.LogOn(gatherData);
                res.setExamineState("有散杂货预约");
            }
            return res;
        }*/

    }
}
